/* cutcopy v0.1 by nyanonon */
/* t@Cw肵ʒuAw肵eʂAoCiJbgďo͂ */

#include <stdio.h>
#include <fcntl.h>
#include <sys/stat.h>

int main(int argc,char *argv[]) {
	int fd1,fd2,rt,ts,rs,ws,i,pf;
	long rc;
	__int64 of,sz,fs,bs;
	char buf[65536];

	/* Ȃ΃wv\ďI */
	if(argc<4) {
		printf("usage: cutcopy source destination size [-b block] [-p percent] [-o offset]\n");
		return -1;
	}

	/* ̓t@CJ */
	fd1=_open(argv[1],_O_BINARY|_O_RDONLY|_O_SEQUENTIAL);
	if(fd1<0) {
		printf("input file is not open.\n");
		_close(fd1);
		return -1;
	}
	rc=_lseeki64(fd1,0,SEEK_END);
	if(rc==-1L) {
		printf("input file seek end error.\n");
		_close(fd1);
		return -1;
	}
	fs=_telli64(fd1);

	/* IvVp[^擾 */
	bs=1;
	pf=0;
	i=4;
	while(i<argc) {
		/* -b IvVȂ擾 */
		if(strncmp(argv[i],"-b",2)==0) {
			rt=sscanf(argv[i],"-b%I64d",&bs);
			if(rt<1) {
				printf("-b option syntax error.\n");
				_close(fd1);
				return -1;
			}
			
		}
		/* -p IvVȂJnʒuŜ̃p[Ze[WŎ擾 */
		else if(strncmp(argv[i],"-p",2)==0) {
			rt=sscanf(argv[i],"-p%I64d",&of);
			if(rt<1) {
				printf("-p option syntax error.\n");
				_close(fd1);
				return -1;
			}
			if(of<0 || of>100) {
				printf("-p option range error.\n");
				_close(fd1);
				return -1;
			}
			of=((fs/bs)*of/100)*bs;
			pf=1;
		}
		/* -o IvVȂJnʒu擾 */
		else if(strncmp(argv[i],"-o",2)==0) {
			rt=sscanf(argv[i],"-o%I64d",&of);
			if(rt<1) {
				printf("-o option syntax error.\n");
				_close(fd1);
				return -1;
			}
			of=of*bs;
			if(of<0) {
				of=0-of;
				of=((fs/bs)*bs)-of;
			}
			if(of>fs) {
				printf("-o option range error.\n");
				_close(fd1);
				return -1;
			}
			pf=1;
		}
		/* ݂ȂIvVȂ΃G[ */
		else {
			printf("unknown option error.\n");
			_close(fd1);
			return -1;
		}
		i++;
	}

	/* Jnʒu̎w肪ΐ擪 */
	if(pf==0) of=0;

	/* TCY擾 */
	rt=sscanf(argv[3],"%I64d",&sz);
	if(rt<1) {
		printf("size parameter syntax error.\n");
		_close(fd1);
		return -1;
	}
	sz=sz*bs;
	/* }CiXlȂJnʒut */
	if(sz<0) {
		/* Jnʒu̎w肪Ζ */
		if(pf==0) of=((fs/bs)*bs);
		sz=0-sz;
		of=of-sz;
		/* Jnʒu0ɂȂ擪ɂ */
		if(of<0) of=0;
	}

	/* JnʒuƃTCY̍ŏIIȒl\ */
	printf("filesize:%I64d size:%I64d offset:%I64d\n",fs,sz,of);

	/* Jnʒut@CTCYȏȂG[\ďI */
	if(of>fs) {
		printf("file size range error.\n");
		_close(fd1);
		return -1;
	}

	/* Jnʒu{TCYt@CTCY𒴂ĂTCYk߂ */
	if((of+sz)>fs) sz=fs-of;

	/* ̓t@CJnʒuɃV[N */
	rc=_lseeki64(fd1,of,SEEK_SET);
	if(rc==-1L) {
		printf("read file seek error.\n");
		_close(fd1);
		return -1;
	}
	/* o̓t@CJ */
	fd2=_open(argv[2],_O_WRONLY|_O_BINARY|_O_CREAT|_O_TRUNC,_S_IREAD|_S_IWRITE);
	if(fd2<0) {
		printf("output file is not open.\n");
		_close(fd2);
		_close(fd1);
		return -1;
	}
	/* obt@TCYݒ */
	ts=65536;
	/* Ǎeʂ0ɂȂ܂ŏJԂ */
	while(sz>0) {
		/* Ǎeʂobt@TCYȂobt@TCYǍeʂɍ킹 */
		if(sz<ts) ts=sz;
		/* obt@TCYǂݍ */
		rs=_read(fd1,buf,ts);
		if(rs<ts) {
			printf("file read error.\n");
			_close(fd2);
			_close(fd1);
			return -1;
		}
		/* Ǎeʂobt@TCY */
		sz=sz-ts;
		/* obt@TCY */
		ws=_write(fd2,buf,ts);
		if(ws<ts) {
			printf("file write error.\n");
			_close(fd2);
			_close(fd1);
			return -1;
		}
		/* is󋵂Qlɕ\ */
/*		printf("buffer:%d read:%d write:%d remain:%I64d\n",ts,rs,ws,sz);	*/
	}
	/* o̓t@CƓ̓t@CďI */
	_close(fd2);
	_close(fd1);
	return 0;
}
